﻿using UnityEngine;
using System.Collections;
using System.Runtime.InteropServices;

public class AndroidDeepLink : MonoBehaviour
{

    public static string GetURL()
    {

#if UNITY_ANDROID

        try
        {
            using (AndroidJavaClass jclass = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
            {
                AndroidJavaObject activity = jclass.GetStatic<AndroidJavaObject>("currentActivity");
                return(activity.Call<string>("ReturnURL"));
            }
        }
        catch (System.Exception ex)
        {
            Debug.LogWarning(ex.Message);
            return "null";  // or replace with return null;

        }

#endif


#if !UNITY_ANDROID
            return "null";
#endif
    }
}
