﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using IgaworksUnityAOS;

public class OneStoreIapManager : MonoBehaviour
{
    public static OneStoreIapManager Instance;

    public delegate void PayResult<T>(T Result);
    public IapSample iapcore;

    private PayResult<string> OnPayResult;
    private PayResult<string> OnPayPurchase;

    public string appId = "OA00706057";

    public bool DEBUG_MODE = true;

    // Use this for initialization
    void Awake()
    {
        if (Instance == null)
        {
            Instance = this;
            DontDestroyOnLoad(Instance.gameObject);
        }
    }

    // Destroy function
    void Destroy()
    {
        Instance = null;
    }

    // sendPaymentRequest가 끝난 경우 메시지를 화면에 표시해준다.
    // 자체적으로 핸드폰에서 영수증 검증을 끝낸 정보가 들어오나 서버에서 한번더 검증해야한다.
    // 이부분 좀더 세부적으로 사용할수 있게 수정되었습니다. 기존꺼는 사용 안합니다.
    public void PurchaseComplete(string strParam)
    {
        if (OnPayPurchase != null)
            OnPayPurchase(strParam);
    }

    // 결제후 결제 영수증 정보가 들어온다.
    // 이부분 사용 안하게 수정되었습니다.
    public void ResultReceipt(string strParam)
    {
        Debug.Log("ResultReceipt: " + strParam);
        Debug.Log("ResultReceiptLength : " + strParam.Length);

        if (OnPayResult != null)
            OnPayResult(strParam);
    }

    // 개정된 함수
    // PID및 TXID, SIGNDATA가 분리되서 들어오도록 수정했습니다.
    public void PurchaseComplete(string pid, string txid, string signdata)
    {

    }

    // 결제 실패시 호출됨
    public void PurchaseFailed(string message)
    {

    }

    // 안드로이드 라이브러리의 결제 요청 메소드를 호출한다.
    public void CallPaymentRequest(string pid)
    {
        if (iapcore == null)
        {
            Debug.Log("iapcore error");
        } else
        {
            iapcore.RequestPaymenet(pid);
        }
    }

    // 안드로이드 라이브러리의 결제 요청 메소드를 호출한다.
    public void CallPaymentRequest(string pid, PayResult<string> callbackResult, PayResult<string> callbackPurchase = null)
    {
        OnPayResult = callbackResult;
        OnPayPurchase = callbackPurchase;
        iapcore.RequestPaymenet(pid);
    }

    void Update()
    {
        if(Input.GetMouseButtonDown(0))
        {
            CallPaymentRequest("0910062455");
        }
    }
}

